<script lang="ts">
  import { Route } from 'svelte-routing'

  import Dev from './Dev/Dev.svelte'
  import Preview from './Dev/Preview.svelte'
  import Home from './Home.svelte'
  import NotFound from './Shared/NotFound.svelte'
  import Properties from './Properties/Properties.svelte'
  import Property from './Properties/Property.svelte'
  import Search from './Spaces/Search.svelte'
  import Space from './Spaces/Space.svelte'
  import Trait from './Traits/Trait.svelte'
  import Theorem from './Theorems/Theorem.svelte'
  import Theorems from './Theorems/Theorems.svelte'
  import { baseUrl } from '../paths';

  import { Dispatch } from '../actions'
  import { Handler } from '../errors'

  export let dispatch: Dispatch
  export let handler: Handler
</script>

<Route path="{baseUrl}/spaces/:spaceId/properties/:propertyId" let:params>
  <Trait spaceId={params.spaceId} propertyId={params.propertyId} />
</Route>

<Route path="{baseUrl}/spaces/:id/theorems" let:params>
  <Space id={params.id} tab="theorems" />
</Route>
<Route path="{baseUrl}/spaces/:id/properties" let:params>
  <Space id={params.id} tab="properties" />
</Route>
<Route path="{baseUrl}/spaces/:id/references" let:params>
  <Space id={params.id} tab="references" />
</Route>
<Route path="{baseUrl}/spaces/:id" let:params>
  <Space id={params.id} />
</Route>
<Route path="{baseUrl}/spaces" component={Search} />

<Route path="{baseUrl}/properties/:id/theorems" let:params>
  <Property id={params.id} tab="theorems" />
</Route>
<Route path="{baseUrl}/properties/:id/spaces" let:params>
  <Property id={params.id} tab="spaces" />
</Route>
<Route path="{baseUrl}/properties/:id/references" let:params>
  <Property id={params.id} tab="references" />
</Route>
<Route path="{baseUrl}/properties/:id" let:params>
  <Property id={params.id} />
</Route>
<Route path="{baseUrl}/properties" component={Properties} />

<Route path="{baseUrl}/theorems/:id/converse" let:params>
  <Theorem id={params.id} tab="converse" />
</Route>
<Route path="{baseUrl}/theorems/:id/references" let:params>
  <Theorem id={params.id} tab="references" />
</Route>
<Route path="{baseUrl}/theorems/:id" let:params>
  <Theorem id={params.id} />
</Route>
<Route path="{baseUrl}/theorems" component={Theorems} />

<Route path="{baseUrl}/dev/preview" component={Preview} />
<Route path="{baseUrl}/dev" component={Dev} {dispatch} {handler} />
<Route path="{baseUrl}/" component={Home} />

<Route path="*" component={NotFound} />
